<template>
  <v-card class="mb-5" elevation="0" style="border: thin solid rgba(0, 0, 0, 0.12)">
    <v-card-title class="d-flex align-center">
      <v-avatar size="32" class="mr-4 outlined">
        {{ index + 1 }}
      </v-avatar>
      <div v-if="!!leg.departure && !!leg.arrival">
        {{ leg.departure.oaci }} > {{ leg.arrival.oaci }}
      </div>
      <v-spacer></v-spacer>
      <v-btn icon flat size="x-small" class="action" :disabled="archived" data-cy="LegFormDeleteBtn" @click="deleteLeg">
        <v-icon>delete</v-icon>
      </v-btn>
    </v-card-title>
    <v-card-text>
      <v-divider class="mb-6"></v-divider>
      <v-row>
        <v-col cols="12" sm="1">
          <div class="leg-illustration">
            <div class="dot"></div>
            <div class="dashed"></div>
            <div class="dot"></div>
          </div>
        </v-col>
        <v-col cols="12" sm="11">
          <v-row>
            <v-col cols="12" sm="4">
              <Field #default="{ errors, field, value }" :name="`legs.${index}.departure`" rules="required"
                v-model="leg.departure">
                <airport-picker @update:model-value="field.onInput" :model-value="value" label="Départ"
                  data-cy="LegFormDepartureInput" density="compact" :error-messages="errors" :items="airports"
                  :item-title="transformItem" class="required" return-object variant="outlined" :disabled="archived" color="primary">
                </airport-picker>
              </Field>
            </v-col>
            <v-col cols="12" sm="4">
              <Field #default="{ errors, field, value }" :name="`legs.${index}.departureTime`" rules="required"
                v-model="leg.departureTime">
                <v-datetime-picker @update:model-value="field.onInput" :model-value="value" label="Date de départ"
                  data-cy="LegFormDepartureTimeInput" density="compact" :required="true" :errorMessages="errors"
                  :time-picker-props="{ format: '24hr' }" :disabled="archived" color="primary">
                </v-datetime-picker>
              </Field>
            </v-col>
            <v-col cols="12" sm="4">
            </v-col>
            <v-col cols="12" sm="4">
              <Field #default="{ errors, field, value }" :name="`legs.${index}.arrival`" rules="required"
                v-model="leg.arrival">
                <airport-picker @update:model-value="field.onInput" :model-value="value" label="Arrivée"
                  data-cy="LegFormArrivalInput" density="compact" :error-messages="errors" :items="airports"
                  :item-title="transformItem" class="required" return-object variant="outlined" :disabled="archived" color="primary">
                </airport-picker>
              </Field>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script setup lang="ts">

import { Leg } from "~/dto/leg.dto";
import { Airport } from "~/dto/airport.dto";

defineProps<{
  leg: Leg,
  index: number,
  archived?: boolean
}>();

const emit = defineEmits(['deleteLeg'])

const store = useStore();
const airports: Ref<Airport[]> = computed(() => {
  return store.airportsEnabled;
});

const deleteLeg = () => {
  emit('deleteLeg');
}

function transformItem(airport: Airport) {
  if (airport) {
    return `${airport.oaci}${airport.name ? ' - ' + airport.name : ''}`
  }
  return ''
}
</script>

<style lang="scss">
@import "../../../assets/variables.scss";

.leg-illustration {
  display: flex;
  height: 100%;
  flex-direction: column;
  align-items: center;
  justify-content: space-between;
  padding: 25px 0 50px 0;

  $dot-size: 15px;

  .dot {
    height: $dot-size;
    width: $dot-size;
    background-color: $color-primary;
    border-radius: 50%;
  }

  .dashed {
    height: calc(100% - 30px);
    border: none;
    border-right: 1px dashed $grey-light;
    width: 1px;
  }

}
</style>
